/*H**************************************************************************
* $RCSfile: interface.h,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.9 $
* FILE_CVSID:	$Id: interface.h,v 1.9 2003/09/26 07:51:11 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ISPK ײފԂ̪̓
*****************************************************************************/
#ifndef _INTERFACE_H_
#define _INTERFACE_H_

/*_____ ݸٰ ____________________________________________________________*/

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/
/*V**************************************************************************
* O: buffer
*----------------------------------------------------------------------------
* ړI:
* ްċKwɂĎgpMڰтƑS̕ϐ̊i[
*****************************************************************************/
extern Uchar _MemType_  buffer[];		// ۸т̂߂ɎMް
extern Uint16           address;
extern Uint16           end_address;


/*_____ 錾 _______________________________________________________________*/
/*F**************************************************************************
* O: isp_select_memory
*----------------------------------------------------------------------------
* Ұ:
* id: ؗ̈̎ʎq(޲)
*	id = 00		: USER, CODE, FLASH, CRAM
*	id = 01		: EEPROM
*	id = 02		: CUSTOM
*	id = 03		: BOOT
*	id = 04		: XAF
*	id = 05		: HW (ʰ޳ ޲)
*	id = 06		: SIGNATURE (iʰ޳[)
*	id = 07		: LPC_BOOT (LPCKp)
*	id = 128	: MULTICAST
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ؗ̈I
*----------------------------------------------------------------------------
* :
* isp_select_memory(0x04)XAF̈Iт܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern void   isp_select_memory       (Byte id);

/*F**************************************************************************
* O: isp_select_page
*----------------------------------------------------------------------------
* Ұ: * page: ߰ނ̎ʎq(޲)
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ؗ̈64K޲ ߰ނI
*----------------------------------------------------------------------------
* :
* isp_select_page(0x02)؂̑3߰ނIт܂(ڽ͈:128KB`192KB)
*----------------------------------------------------------------------------
* :
* ̊֐64K޲Ă޲Ă܂؋Ԃ̱ڽw肪ǉ܂B
* ߰ނ64K޲Ă܂݂܂B
* Cs߰ނ0(0`64KB)łB
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern void   isp_select_page         (Byte page);

/*F**************************************************************************
* O: isp_erase
*----------------------------------------------------------------------------
* Ұ:
* block: ̎ʎq(޲)
*	block=0x000KB`8KB̉
*	block=0x208KB`16KB̉
*	block=0x4016KB`32KB̉
*	block=0xFF͊Sߏ
* ߂l: ǍDȂTRUEAُ(ޯ)ꍇFALSE
*----------------------------------------------------------------------------
* ړI:
* I؂̉A܂͑I؂̑S
*----------------------------------------------------------------------------
* :
* isp_erase(0xFF)͑IؑSĂ܂B
*----------------------------------------------------------------------------
* :
* 0xFF͑IؑSĂ邽߂̎ʎqłB
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern bit    isp_erase               (Byte block);

/*F**************************************************************************
* O: isp_read
*----------------------------------------------------------------------------
* Ұ: addr: ǂ޲Ăɱڽ(2޲)
* ߂l: ǂݍ݂ɖ肪ꍇ0xFFFFAǂݍ݂̏ꍇ0x00XX
*		  (XX͓ǂݍ޲Ēl)
*----------------------------------------------------------------------------
* ړI:
* I̱ؓڽ(addr)޲ēǂݍ
*----------------------------------------------------------------------------
* :
* isp_read(0x0052)ͱڽ0xMMPP0052(MM=؁APP=߰)޲Ăǂ݂܂B
*----------------------------------------------------------------------------
* :
* Ⴆǂނ̂1޲ĂłĂAisp_read̑isp_read_block֐Ă
* Ƃł܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern Uint16 isp_read                (Uint16 addr);

/*F**************************************************************************
* O: isp_read_block
*----------------------------------------------------------------------------
* Ұ:
* src:	ǂނ߂̒l܂ޕ\̐擪̗vf̱ڽ
* dest:	ɏՕ̐擪̒l̓]ڽ(2޲)
* n:	ǂ޲Đ
* ߂l: ǂݍ݂ȂTRUEAُ(ޯ)ꍇFALSE
*----------------------------------------------------------------------------
* ړI:
* Iؓް̉ǂݍ
*----------------------------------------------------------------------------
* :
* isp_read_block (0x0083, idata_buffer, 0x0A)ͱڽ0x0083`0x008C10޲Ă
* łɏՕɊi[܂B
*----------------------------------------------------------------------------
* :
* ̊֐255޲Ă܂ł̑ʓǂݍ݂gp҂ɋ܂B
* ̊֐͉ʑʓǂݍ݌ĂяoŊtׂłB
* Ⴆǂނ̂1޲ĂłĂAisp_read̑isp_read_block֐Ă
* Ƃł܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern bit    isp_read_block           (Uint16 src, Byte _MemType_* dest, Byte n);

/*F**************************************************************************
* O: isp_write
*----------------------------------------------------------------------------
* Ұ:
* addr:		Ȃ΂ȂȂ޲Ă̱ڽ(޲)
* value:	l(1޲)
* ߂l: 폑݂ȂTRUEAُ(ޯ)ꍇFALSE
*----------------------------------------------------------------------------
* ړI:
* I̱ؓڽ(addr)޲Ă
*----------------------------------------------------------------------------
* :
* isp_write(0x0001, 0xAA)ͱڽ$0001$AA܂B
*----------------------------------------------------------------------------
* :
* Ⴆ̂1޲ĂłĂAisp_writȇisp_write_block֐Ă
* Ƃł܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern bit    isp_write               (Uint16 addr, Uchar value);

/*F**************************************************************************
* O: isp_write_block
*----------------------------------------------------------------------------
* Ұ:
* src:	l܂ޕ\̐擪vf̱ڽ
* dest:	\̐擪̒l̓]ڽ(2޲)
* n:	l̐
* ߂l: 폑݂ȂTRUEAُ(ޯ)ꍇFALSE
*----------------------------------------------------------------------------
* ړI:
* Iؓް̉
*----------------------------------------------------------------------------
* :
* isp_write_block (idata_table, 0x0083, 0x0A)͕\(idata_table)Ɋ܂܂10޲
* 0x00830x008Cɏ܂B
*----------------------------------------------------------------------------
* :
* ̊֐255޲Ă܂ł݂̉̏gp҂ɋ܂B
* ̊֐͒߰ޏ݌ĂяoŊtׂłB
* Ⴆ݂1޲ĂłĂAisp_writȇisp_write_block֐
* ĂԂƂł܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern bit    isp_write_block           (Byte _MemType_* src, Uint16 dest, Byte n);

/*F**************************************************************************
* O: isp_reset
*----------------------------------------------------------------------------
* Ұ:
* config: ؾĔCӑII
*	config=0x00 : ʰ޳ ؾ
*	config=0x01 : SҰŎw肳ꂽڽ֔
* ߂l: ؾĂȂTRUEAُ(ޯ)ꍇFALSE
*----------------------------------------------------------------------------
* ړI:
* ؾĂ܂͖
*----------------------------------------------------------------------------
* :
* isp_erase(0x00)ʰ޳ ؾĂs܂B
*----------------------------------------------------------------------------
* :
* `Ԑݒ޲Ăgp҂ɖ܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern bit    isp_reset               (Byte config);

/*F**************************************************************************
* O: isp_blank_check
*----------------------------------------------------------------------------
* Ұ:
* start:	Jnڽ(2޲)
* end:		Iڽ(2޲)
* ߂l: I؂󔒂Ȃ0x00000000A܂͑I؂󔒂łȂ
* 0xFFFFXXXX(XXXX͋󔒂łȂŏ޲Ă̱ڽ܂݂܂)B
*----------------------------------------------------------------------------
* ړI:
* I؂JnڽƏIڽԂŋ󔒂ǂ܂B
*----------------------------------------------------------------------------
* :
* isp_blank_check(0x0000, 0x7FFF)͑I؂32K޲Ă󔒂ǂ𒲂ׂ
* B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
extern Uint32 isp_blank_check         (Uint16 start,Uint16 end);

#endif  /* INTERFACE_H */
