/*H**************************************************************************
* $RCSfile: scheduler.h,v $
*----------------------------------------------------------------------------
* Copyright (c) 2002 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.8 $
* FILE_CVSID:	$Id: scheduler.h,v 1.8 2003/07/04 16:43:33 njourdan Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧ق͌v敔`ƁAv敔ɂĎsׂƊ֐܂݂܂B
*
* :
* SCHEDULER_TICKFPERconfig.hŒ`܂B
*****************************************************************************/

#ifndef _SCHEDULER_H_
#define _SCHEDULER_H_

/*_____ ݸٰ ____________________________________________________________*/
#ifdef KEIL
#include <intrins.h>
#define Wait_semaphore(a) while(!_testbit_(a))
#else
#define Wait_semaphore(a) while(!(a)) (a) = FALSE
#endif

/*_____ ϸ ________________________________________________________________*/

/*----- v敔` -----*/
#define SCHEDULER_CUSTOM	0
#define SCHEDULER_TIMED		1
#define SCHEDULER_TASK		2
#define SCHEDULER_FREE		3

#if 0
/*----- v敔v -----*/
#define SCH_TIMER0			0
#define SCH_TIMER1			1
#define SCH_TIMER2			2
/*----- v敔`Ԑݒ -----*/
#define SCH_TIMER			SCH_TIMER0	/* SCH_TIMER0, SCH_TIMER1, SCH_TIMER2 */
/*----- v敔v`Ԑݒ -----*/
#define TIM_ADJUST			(Byte)4		/* ݸޒ̂߂ɕύXׂ */
#define TIM_LOW				LOW(65536 - (SCHEDULER_TICK * (FT0_IN / 6)) + TIM_ADJUST)
#define TIM_HIGH			HIGH(65536 - (SCHEDULER_TICK * (FT0_IN / 6)))
#endif

#ifdef Scheduler_time_init
  extern  void Scheduler_time_init   (void);
#endif

#ifdef Scheduler_task_1_init
  extern  void Scheduler_task_1_init (void);
#else
  // SĂɉď]܂Ȃꍇ͈ȉsĂB
  // #define Scheduler_task_1_init scheduler_empty_fct
  #error Scheduler_task_1_initcongif.ḩقŒ`Ȃ΂Ȃ܂B
#endif
#ifdef Scheduler_task_2_init
  extern  void Scheduler_task_2_init (void);
#endif
#ifdef Scheduler_task_3_init
  extern  void Scheduler_task_3_init (void);
#endif
#ifdef Scheduler_task_4_init
  extern  void Scheduler_task_4_init (void);
#endif
#ifdef Scheduler_task_5_init
  extern  void Scheduler_task_5_init (void);
#endif
#ifdef Scheduler_task_6_init
  extern  void Scheduler_task_6_init (void);
#endif
#ifdef Scheduler_task_7_init
  extern  void Scheduler_task_7_init (void);
#endif
#ifdef Scheduler_task_8_init
  extern  void Scheduler_task_8_init (void);
#endif
#ifdef Scheduler_task_9_init
  extern  void Scheduler_task_9_init (void);
#endif
#ifdef Scheduler_task_10_init
  extern  void Scheduler_task_10_init (void);
#endif
#ifdef Scheduler_task_11_init
  extern  void Scheduler_task_11_init (void);
#endif

#ifdef Scheduler_task_1
  extern  void Scheduler_task_1 (void);
#else
  // SĂɉčƂ]܂Ȃꍇ͈ȉsĂB
  // #define Scheduler_task_1 scheduler_empty_fct
  #error Scheduler_task_1congif.ḩقŒ`Ȃ΂Ȃ܂B
#endif
#ifdef Scheduler_task_2
  extern  void Scheduler_task_2 (void);
#endif
#ifdef Scheduler_task_3
  extern  void Scheduler_task_3 (void);
#endif
#ifdef Scheduler_task_4
  extern  void Scheduler_task_4 (void);
#endif
#ifdef Scheduler_task_5
  extern  void Scheduler_task_5 (void);
#endif
#ifdef Scheduler_task_6
  extern  void Scheduler_task_6 (void);
#endif
#ifdef Scheduler_task_7
  extern  void Scheduler_task_7 (void);
#endif
#ifdef Scheduler_task_8
  extern  void Scheduler_task_8 (void);
#endif
#ifdef Scheduler_task_9
  extern  void Scheduler_task_9 (void);
#endif
#ifdef Scheduler_task_10
  extern  void Scheduler_task_10 (void);
#endif
#ifdef Scheduler_task_11
  extern  void Scheduler_task_11 (void);
#endif

/*_____ ` _______________________________________________________________*/
#if SCHEDULER_TYPE != SCHEDULER_FREE
extern  bit   scheduler_tick_flag;
#endif

#ifdef TOKEN_MODE
extern Uchar token;
#define TOKEN_FREE		0
#endif

/*_____ 錾 _______________________________________________________________*/
void scheduler_init         (void);
void scheduler_tasks        (void);
void scheduler              (void);
void scheduler_empty_fct    (void);

#ifndef SCHEDULER_TYPE
  #error config.h fileSCHEDULER_TYPE`Ȃ΂Ȃ܂B
#elif SCHEDULER_TYPE == SCHEDULER_FREE
  #define Scheduler_set_tick_flag()
  #define Scheduler_reset_tick_flag()
#elif SCHEDULER_TYPE == SCHEDULER_TIMED
  #define Scheduler_new_schedule()		Wait_semaphore(scheduler_tick_flag)
  #define Scheduler_set_tick_flag()		(scheduler_tick_flag = TRUE)
  #define Scheduler_reset_tick_flag()	(scheduler_tick_flag = FALSE)
#elif SCHEDULER_TYPE == SCHEDULER_TASK
  #define Scheduler_call_next_task()	Wait_semaphore(scheduler_tick_flag)
  #define Scheduler_set_tick_flag()		(scheduler_tick_flag = TRUE)
  #define Scheduler_reset_tick_flag()	(scheduler_tick_flag = FALSE)
#elif SCHEDULER_TYPE == SCHEDULER_CUSTOM
  #error Scheduler_new_scheduleScheduler_call_next_taskϸۂƊ֐̍\ݒmɂĂB
  #define Scheduler_set_tick_flag()		(scheduler_tick_flag = TRUE)
  #define Scheduler_reset_tick_flag()	(scheduler_tick_flag = FALSE)
#endif

#ifndef Scheduler_call_next_task
  #define Scheduler_call_next_task()
#endif
#ifndef Scheduler_new_schedule
  #define Scheduler_new_schedule()
#endif
#ifndef Scheduler_call_next_init
  #define Scheduler_call_next_init()
#endif

#endif /* _SCHEDULER_H_ */
