/*C**************************************************************************
* $RCSfile: scheduler.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2002 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $      
* :			$Revision: 1.9 $     
* FILE_CVSID:	$Id: scheduler.c,v 1.9 2003/07/04 16:43:32 njourdan Exp $       
*----------------------------------------------------------------------------
* ړI:
* ̧ق͌v敔ٰ݂܂݂܂B
*
* :
* `Ԑݒ:
* - scheduler.hͯ ̧ٓSCHEDULER_TYPE
* - ŒƔԍ1p̍ƂƏ`Ȃ΂Ȃ܂B
*****************************************************************************/

/*_____ ݸٰ ____________________________________________________________*/
#define _SCHEDULER_C_
#include "config.h"			/* ђ` */
#include "scheduler.h"		/* v敔` */

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/
#if SCHEDULER_TYPE != SCHEDULER_FREE
/*V**************************************************************************
* O: scheduler_tick_flag
*----------------------------------------------------------------------------
* ړI:
* SCHEDULER_TYPE != SCHEDULER_FREEA׸ނƌĂяo𐧌䂵܂B
*****************************************************************************/
  bit   scheduler_tick_flag;
#endif

#ifdef TOKEN_MODE
/*V**************************************************************************
* O: token
*----------------------------------------------------------------------------
* ړI:
* ̍ƂɎŝ邽߂Ɏgp邱Ƃł܂B
* Ƃ͎sOɕW͂󂢂Ă邩𒲂ׂ܂BW͂󂢂Ă΁As
* n߂ł̍Ƃ͂𔽓]Ađs҂Ă鎟̍Ƃ߂Ɏs
* ̍ŌłJ܂B
*****************************************************************************/
Uchar token;
#endif

/*_____ 錾 _______________________________________________________________*/
/*F**************************************************************************
* O: scheduler_init
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* v敔
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* Task_x_init()Task_x_fct()config.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void scheduler_init (void)
{
#ifdef Scheduler_time_init
  Scheduler_time_init();		// Ԋn
#endif
#ifdef TOKEN_MODE
  token=TOKEN_FREE;
#endif
#ifdef Scheduler_task_1_init
  Scheduler_task_1_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_2_init
  Scheduler_task_2_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_3_init
  Scheduler_task_3_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_4_init
  Scheduler_task_4_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_5_init
  Scheduler_task_5_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_6_init
  Scheduler_task_6_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_7_init
  Scheduler_task_7_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_8_init
  Scheduler_task_8_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_9_init
  Scheduler_task_9_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_10_init
  Scheduler_task_10_init();
  Scheduler_call_next_init();
#endif
#ifdef Scheduler_task_11_init
  Scheduler_task_11_init();
  Scheduler_call_next_init();
#endif
  Scheduler_reset_tick_flag();
}

/*F**************************************************************************
* O: scheduler_tasks
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* Ǝsv敔
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void scheduler_tasks (void)
{
  scheduler_empty_fct();	// ̊֐gpȂꍇɖĂяoČx邽߂
#ifdef SCHEDULER_ENABLE_IT
  Enable_interrupt();		// S̊荞݋
#endif
  for(;;)
  {
	Scheduler_new_schedule();
  #ifdef Scheduler_task_1
	Scheduler_task_1();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_2
	Scheduler_task_2();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_3
	Scheduler_task_3();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_4
	Scheduler_task_4();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_5
	Scheduler_task_5();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_6
	Scheduler_task_6();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_7
	Scheduler_task_7();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_8
	Scheduler_task_8();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_9
	Scheduler_task_9();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_10
	Scheduler_task_10();
	Scheduler_call_next_task();
  #endif
  #ifdef Scheduler_task_11
	Scheduler_task_11();
	Scheduler_call_next_task();
  #endif
  }
}

/*F**************************************************************************
* O: scheduler
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* v敔đs邽߂ɂ̍ƂPɌĂяo
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void scheduler (void)
{
  scheduler_init();
  scheduler_tasks();
}

/*F**************************************************************************
* O: scheduler_empty_fct
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* ̊֐͉܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void scheduler_empty_fct (void)
{
}

#if 0	// v敔PɕύX邽߂ChejudoɂĂgp̧ق̍Ō
#include "lib_mcu\timer\timer_drv.h"		/* v` */

extern  data    Byte    gl_cpt_tick;		/* Sʌvv */
extern  data    Byte    gl_kbd_tick;		/* ߯ތvv */
extern  data    Byte    gl_mem_tick;		/* ،vv */

#if (SCH_TIMER == SCH_TIMER0)
/****************************************************************************
* O: sch_time_init
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* v敔Ԋ(/0)
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* 16ޯČv`Ԃ̎Ԍv
* T0_PRIOconfig.hŒ`ׂ
* TIM_LOWTIM_HIGHscheduler.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void sch_time_init (void)
{
  T0_init(T0_NOT_GATED, T0_TIMER, T0_MODE_1);
  T0_set_low(TIM_LOW);
  T0_set_high(TIM_HIGH);
  t0_set_prio(T0_PRIO);						/* D挠\ݒ */
  T0_enable_int();							/* 荞݋ */
  T0_start();								/* Ԋn */
}

/****************************************************************************
* O: sch_timer_int
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* /0荞݊֐
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* RQ_T0extsnd1.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
******************************************************************************/
Interrupt (sch_timer_int(void), IRQ_T0) 
{
//  T0_stop();							/* v~ */
  T0_set_low(TIM_LOW);					/* vĐݒ */ 
  T0_set_high(TIM_HIGH);
//  T0_start();							/* vĎn */

#if (SCH_TYPE != SCH_FREE)
  sch_tick_flag = TRUE;
#endif
  /* increment task tick counters */
  gl_cpt_tick++;						/* Sʌv */
  gl_kbd_tick++;						/* ߯ތv */
  gl_mem_tick++;						/* ،v */
}

#elif (SCH_TIMER == SCH_TIMER1)
/****************************************************************************
* O: sch_time_init
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* v敔Ԋ(/1)
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* 16ޯČv`Ԃ̎Ԍv
* T1_PRIOconfig.hŒ`ׂ
* TIM_LOWTIM_HIGHscheduler.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void sch_time_init (void)
{
  T1_init(T1_NOT_GATED, T1_TIMER, T1_MODE_1);
  T1_set_low(TIM_LOW);
  T1_set_high(TIM_HIGH);
  t1_set_prio(T1_PRIO);						/* D挠\ݒ */
  T1_enable_int();							/* 荞݋ */
  T1_start();								/* Ԋn */
}

/****************************************************************************
* O: sch_timer_int
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* /1荞݊֐
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* IRQ_T1extsnd1.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
Interrupt (sch_timer_int(void), IRQ_T1) 
{
//  T1_stop();					/* v~ */
  T1_set_low(TIM_LOW);			/* vĐݒ */
  T1_set_high(TIM_HIGH);
//  T1_start();					/* vĎn */

#if (SCH_TYPE != SCH_FREE)
  sch_tick_flag = TRUE;
#endif

  gl_cpt_tick++;
}

#elif (SCH_TIMER == SCH_TIMER2)
/****************************************************************************
* O: sch_time_init
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* v敔Ԋ(/2)
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* 16ޯČv`Ԃ̎Ԍv
* T2_PRIOconfig.hŒ`ׂ
* TIM_LOWTIM_HIGHscheduler.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void sch_time_init (void)
{
  T2_init(T2_AUTO_RELOAD, T2_TIMER, T2_NOT_GATED);
  T2_set_low(TIM_LOW);
  T2_set_high(TIM_HIGH);
  t2_set_prio(T2_PRIO);						/* D挠\ݒ */
  T2_enable_int();							/* 荞݋ */
  T2_start();								/* Ԋn */
}

/****************************************************************************
* O: sch_timer_int
*----------------------------------------------------------------------------
* Ұ:
*
* ߂l:
*----------------------------------------------------------------------------
* ړI:
* /2荞݊֐
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* IRQ_T2extsnd1.hŒ`܂B
*----------------------------------------------------------------------------
* Kv:
******************************************************************************/
Interrupt (sch_timer_int(void), IRQ_T2) 
{
  T2_clr_ovf;					/* 荞݉ */

#if (SCH_TYPE != SCH_FREE)
  sch_tick_flag = TRUE;
#endif
  gl_cpt_tick++;
}
#endif

#endif
